{ 
  open Parser

  (*These code is questionable, For now just leave them here. 
    let incr_lineno lexbuf =
      let pos = lexbuf.Lexing.lex_curr_p in
          lexbuf.Lexing.lex_curr_p <- { pos with
              Lexing.pos_lnum = pos.Lexing.pos_lnum + 1;
              Lexing.pos_bol = pos.Lexing.pos_cnum;
          }
   *)
}

rule token = parse 
  [' ' '\t' '\n' '\r'] {token lexbuf} (*White spaces*)
| "/*" {comment lexbuf}               


(* Groupinp *)
| "begin"    {LBRACE}
| "end"      {RBRACE}
| '('      {LPAREN}	
| ')'      {RPAREN}
| '['	   {LBRACK}
| ']'	   {RBRACK}
| "[|"	   {LARRAY}
| "|]"	   {RARRAY}
(* Operators: *)
  (* Arithmetic: *)
| '+'      {PLUS}
| '-'      {MINUS}
| '*'      {TIMES}
| '/' 		 {DIVIDE}
| "++"     {INCR}
| "--"     {DECR}
   (* Comparison: *)
| '>'      {GT}
| '<'      {LT}
| '='      {EQ}
| "!="     {NOTEQ}
| ">="     {GTEQ}
| "<="     {LTEQ}
   (* Logical: *)
| "not"    {NOT}
| "and"    {AND}
| "or"     {OR}
(* Other: *)
| '.'      {DOT}
| ','      {COMMA}
| ';'      {SEMI}
| '~'     {ASSIGN}
(* scope *)
(* Types *)
| "int"    {INT}
| "bool"   {BOOLEAN}
| "string" {STRING}
| "Array"  {ARRAY}
| "Grid"   {GRID}
| "Cell"   {CELL}
| "Row"    {ROW}
| "CheckGrid" {CHECKGRID}
| "Column" {COLUMN}
| "Diagnal" {DIAGNAL}
| "Block"  {BLOCK}
| "Stack"  {STACK}  (*3 vertically connected blocks*)
| "Band"   {BAND}   (*3 horizontally connected blocks*)
(* Keywords: *)
| "if"     {IF}
| "else"   {ELSE}
| "for"    {FOR}
| "while"  {WHILE}
| "true"   {TRUE(true)}
| "false"  {FALSE(false)}
| "left"   {LEFT}
| "right"  {RIGHT}              (*?*)
| "return" {RETURN}
(*give a sample sentence*)
| "MakeVisible"    {VISIBLE}    (*MakeVisible*)
(*| "IsRepeatable"   {REPEATABLE} *)(*Whether the values in the specified cells can be duplicates.*)
(*| "DefineBlock"    {DEFINEBLOCK}  *) (*Allows the programmer to define a sub-square of the grid. Its row and column dimensions must be factors of the grid’s rows and columns dimensions respectively.*)
(*| "SetAsGiven"	{SETASGIVEN}*)
(*give a sample sentence*)
| "SumOfRows"      {SUMROW}     (*The total that all the values in each row must sum to.*)
| "SumOfColumns"      {SUMCOL}     (*The total that all the values in each column must sum to.*)
| "SumOfDiagnals"     {SUMDIAG}    (*The total that all the values in each diagonal must sum to.*)
| "SumOfBlocks"    {SUMBLOCK}   (*The total that all the values in each block must sum to.*)
| "MaxValueOfRows"         {MAXROW}     (*What the maximum value of each row is permitted to be.*)
| "MaxValueOfColumns"         {MAXCOL}     (*What the maximum value of each column is permitted to be.*)
| "MaxValueOfDiagnals"        {MAXDIAG}    (*What the maximum value of each diagonal is permitted to be.*)
| "MaxValueOfBlocks"       {MAXBLOCK}   (*What the maximum value of each block is permitted to be.*)
| "MinValueOfRows"         {MINROW}     (*Do we still need this? what the minimum value of each row is permitted to be.*)
| "MinValueOfColumns"         {MINCOL}     (*Do we still need this? what the minimum value of each row is permitted to be.*)
| "MinValueOfDiagnals"        {MINDIAG}    (*Do we still need this? what the minimum value of each diagonal is permitted to be.*)
| "MinValueOfBlocks"       {MINBLOCK}   (*Do we still need this? what the minimum value of each block is permitted to be.*)
| ['0'-'9']+ as lit {LITERAL(int_of_string lit)}
| ['a'-'z' 'A'-'Z' '_']['a'-'z' 'A'-'Z' '0'-'9' '_']* as lit { ID(lit) }
| '\"'[^ '\"']*'\"' as
	lxm { STRINGLITERAL(String.sub lxm 1 ((String.length lxm)-2)) }
| eof      {EOF}                      (*End of file*)
| _ as char { raise (Failure("illegal character "^Char.escaped char))}
(*These code is questionable. For now just leave them here.
  | _ as char ( 
              let pos = lexbuf.Lexing.lex_curr_p in 
                  raise (failure("Illegal character: " ^ Char.escaped char
                  ^ " in line #" ^ (string_of_int pos.Lexing.pos_lnum)))
*)

and comment = parse 
  "*/" {token lexbuf}
| _ {comment lexbuf}
